package compiler.intermediate;

import es.uned.compiler.intermediate.OperandIF;

/**
 * Clase que representa un operando etiqueta del cdigo intermedio
 *
 */
public class Label
    implements OperandIF 
{
    String name  = null;
    
    /**
     * Constructor for Variable.
     * @param name The name.
     */
    public Label (String name)
    {
        this.name = name;
    }

    /**
     * Returns the name.
     * @return Returns the name.
     */
    public String getName ()
    {
        return name;
    }

    /**
     * Sets The name.
     * @param name The name to set.
     */
    public void setName (String name)
    {
        this.name = name;
    }
    
    /**
     * Compares this object with another one.
     * @param other the other object.
     * @return true if two objects has the same properties.
     */
    public boolean equals (Object other)
    {
        if (this == other)
        {
            return true;
        }
        if (!(other instanceof Label))
        {
            return false;
        }
        
        final Label anOperandLabel = (Label) other;
        return ((name == anOperandLabel.name) ||
                (name.equals (anOperandLabel.name)));
    }

    /**
     * Returns a hash code for the object.
     */
    public int hashCode ()
    {
        return 255 * ((name != null)? name.hashCode () : 0);
    } 

    /**
     * Return a string representing the object.
     * @return a string representing the object.
     */
    public String toString ()
    {        
        return name;
    }
}
