package compiler.semantic.symbol;

import es.uned.compiler.semantic.symbol.ScopeIF;
import es.uned.compiler.semantic.symbol.SymbolBase;
import es.uned.compiler.semantic.type.TypeIF;

/**
 * Representa una constante en la tabla de s�mbolos.
 * 
 * Ha de ser implementada por el estudiante. 
 *
 */
public class SymbolConstant
        extends SymbolBase {

    private int valor;

    public int getValor() {
        return valor;
    }

    public void setValor(int valor) {
        this.valor = valor;
    }

    /**
     * Constructor for SymbolBase.
     * @param scope The symbol scope.
     * @param name The symbol name.
     * @param type The symbol type.
     */
    public SymbolConstant(ScopeIF scope,
            String name,
            TypeIF type,
            int valor) {
        super(scope, name, type);
        this.setValor(valor);
    }

    /**
     * Compares this object with another one.
     * @param other the other object.
     * @return true if two objects has the same properties.
     */
    public boolean equals(Object other) {
        // IMPORTANTE: a implementar por el estudiante
        return super.equals(other);
    }

    /**
     * Returns a hash code for the object.
     */
    public int hashCode() {
        // IMPORTANTE: a implementar por el estudiante
        return super.hashCode();
    }

    /**
     * Return a string representing the object.
     * @return a string representing the object.
     */
    public String toString() {
        // IMPORTANTE: a implementar por el estudiante
        //return super.toString();
        return "Constante simbolica: N:" + this.getName() + ", T:" + this.getType() + ", V:" + this.getValor();
    }
}
