package compiler.semantic.symbol;

import es.uned.compiler.semantic.symbol.ScopeIF;
import es.uned.compiler.semantic.symbol.SymbolBase;
import es.uned.compiler.semantic.type.TypeIF;

/**
 * Clase que representa una variable en la tabla de smbolos
 * 
 * Ha de ser implementada por el estudiante
 *
 */
public class SymbolParameter
    extends SymbolBase
{  

    private Integer direccion;

    /**
     * Constructor for SymbolBase.
     * @param scope The symbol scope.
     * @param name The symbol name.
     * @param type The symbol type.
     */
    public SymbolParameter (ScopeIF scope, 
                           String name,
                           TypeIF type)
    {
        super (scope, name, type);
    }

    public SymbolParameter (ScopeIF scope,
                           String name,
                           TypeIF type,
                           Integer direccion)
    {
        super (scope, name, type);
        this.direccion=direccion;
    }

    public Integer getDireccion() {
        return direccion;
    }

    public void setDireccion(Integer direccion) {
        this.direccion = direccion;
    }

    /**
     * Compares this object with another one.
     * @param other the other object.
     * @return true if two objects has the same properties.
     */
    public boolean equals (Object other)
    {
      // IMPORTANTE: a implementar por el estudiante
      return super.equals(other);
    }

    /**
     * Returns a hash code for the object.
     */
    public int hashCode ()
    {
       // IMPORTANTE: a implementar por el estudiante
       return super.hashCode();
    } 

    /**
     * Return a string representing the object.
     * @return a string representing the object.
     */
    public String toString ()
    {
       // IMPORTANTE: a implementar por el estudiante
       //return super.toString();
        return "Parametro: N:"+ this.getName() + " T:"  + this.getType() + ", D:" + this.getDireccion()+ " Ambito: " + this.getScope();
    } 
}
