package compiler.semantic.symbol;

//import compiler.CompilerContext;
//import es.uned.compiler.semantic.SemanticErrorManager;
import es.uned.compiler.semantic.symbol.ScopeIF;
import es.uned.compiler.semantic.symbol.SymbolBase;
import es.uned.compiler.semantic.type.TypeIF;

/**
 * Clase que representa una variable en la tabla de smbolos
 * 
 * Ha de ser implementada por el estudiante
 *
 */
public class SymbolVariable
        extends SymbolBase {

    private Integer valor;
    private Integer direccion;
    private Integer tamanyo;

    //SemanticErrorManager semanticErrorManager = CompilerContext.getSemanticErrorManager();
    public Integer getValor() {
        return valor;
    }

    public void setValor(Integer valor) {
        this.valor = valor;
    }

    public Integer getDireccion() {
        return direccion;
    }

    public void setDireccion(Integer direccion) {
        this.direccion = direccion;
    }

    public Integer getTamanyo() {
        return tamanyo;
    }

    public void setTamanyo(Integer tamanyo) {
        this.tamanyo = tamanyo;
    }

    /**
     * Constructor for SymbolBase.
     * @param scope The symbol scope.
     * @param name The symbol name.
     * @param type The symbol type.
     */
    public SymbolVariable(ScopeIF scope,
            String name,
            TypeIF type,
            Integer valorentrada) {
        super(scope, name, type);
        if (valorentrada != null) {
            this.setValor(valorentrada);
        }
    }

    /**
     * Constructor for SymbolBase.
     * @param scope The symbol scope.
     * @param name The symbol name.
     * @param type The symbol type.
     */
    public SymbolVariable(ScopeIF scope,
            String name,
            TypeIF type,
            Integer valorentrada, Integer desplazamientoentrada, Integer tamanyoentrada) {
        super(scope, name, type);
        if (valorentrada != null) {
            this.setValor(valorentrada);
        }
        this.setDireccion(desplazamientoentrada);
        this.setTamanyo(tamanyoentrada);
    }

    /**
     * Compares this object with another one.
     * @param other the other object.
     * @return true if two objects has the same properties.
     */
    public boolean equals(Object other) {
        // IMPORTANTE: a implementar por el estudiante
        return super.equals(other);
    }

    /**
     * Returns a hash code for the object.
     */
    public int hashCode() {
        // IMPORTANTE: a implementar por el estudiante
        return super.hashCode();
    }

    /**
     * Return a string representing the object.
     * @return a string representing the object.
     */
    public String toString() {
        // IMPORTANTE: a implementar por el estudiante
        //return super.toString();
        return "Variable Simple: N:" + this.getName() + ", T:" + this.getType().getName() + ", V:" + this.getValor()+ ", D:" + this.getDireccion()+ ", T:" + this.getTamanyo();
    }
}
