package compiler.semantic.type;

import es.uned.compiler.semantic.symbol.ScopeIF;
import es.uned.compiler.semantic.type.TypeBase;
import es.uned.compiler.semantic.type.TypeIF;

/**
 * Clase que representa un tipo Array.
 * 
 * Ha de ser implementada por el estudiante
 *
 */

public class TypeArray
    extends TypeBase
{   
    private int size;
	
	/**
	 * Constructor for TypeArray
	 * @param scope
	 */
	public TypeArray(ScopeIF scope) {
		super(scope);
		
	}
	
	/**
	 * Constructor for TypeArray
	 * @param scope
	 * @param name
	 */
	public TypeArray(ScopeIF scope, String name) {
		super(scope, name);
		
	}
	
    /**
     * Compares this object with another one.
     * @param other the other object.
     * @return true if two objects has the same properties.
     */
    public boolean equals (Object other)
    {
      // IMPORTANTE: a implementar por el estudiante
      //return super.equals(other);
        if(this == other) return true;
        if(!(other instanceof TypeIF)) return false;
        return ((TypeIF)other).getName().equalsIgnoreCase(this.getName());
    }

    /**
     * Returns a hash code for the object.
     */
    public int hashCode ()
    {
       // IMPORTANTE: a implementar por el estudiante
       //return super.hashCode();
        return 255*getName().hashCode()+getScope().hashCode();
    } 

    /**
     * Return a string representing the object.
     * @return a string representing the object.
     */
    public String toString ()
    {
       // IMPORTANTE: a implementar por el estudiante
       //return super.toString();
        return "Super.toString: "+ super.toString()+"; TypeArray: mbito(Nivel+ID+Nombre): "+ 
                this.getScope().getLevel()+"-"+getScope().getId()+"-"+getScope().getName()+"; Nombre: "+this.getName();
    } 

    public int getSize() {
        return size;
    }

    public void setSize(int size) {
        this.size = size;
             
    }
}
