package compiler.semantic.type;

import compiler.CompilerContext;
import compiler.semantic.symbol.SymbolParameter;
import es.uned.compiler.semantic.type.TypeIF;
import java.util.List;
import es.uned.compiler.semantic.SemanticErrorManager;
import es.uned.compiler.semantic.symbol.ScopeIF;
import es.uned.compiler.semantic.type.TypeBase;
import java.util.ArrayList;
import java.util.Iterator;

/**
 * Clase que representa un tipo Funcin.
 * Ha de ser implementada por el estudiante
 *
 */
public class TypeFunction
        extends TypeProcedure {

    SemanticErrorManager semanticErrorManager = CompilerContext.getSemanticErrorManager();
    private List parametros;
    private TypeIF retorno;

    public Integer getSize() {
        //####MEMORIA: No se si necesitare el tamao del tipo funcion.
        return 10000;
    }

    public List getParametros() {
        return parametros;
    }

    public void setParametros(List parametros) {
        this.parametros = parametros;
    }

    public TypeIF getRetorno() {
        return retorno;
    }

    public void setRetorno(TypeIF retorno) {
        this.retorno = retorno;
    }

    public boolean casaNumeroParametros(int parametros) {
        return (parametros == this.getParametros().size());
    }

    public boolean casaParametro(int pos, String tipo) {
        //semanticErrorManager.semanticInfo("TENGO  --> posicion:"+pos + " tipo:" + tipo);
        //semanticErrorManager.semanticInfo("ESPERO -->                    tipo:" + ((SymbolParameter) this.getParametros().get(pos)).getType().getName().toString());
        return ((SymbolParameter) this.getParametros().get(pos)).getType().getName().toString().equals(tipo);
//        return false;
    }

    /**
     * Constructor for TypeBase.
     * @param scope The scope.
     */
    public TypeFunction(ScopeIF scope) {
        super(scope);
        this.parametros = new ArrayList();
    }

    /**
     * Constructor for TypeBase.
     * @param scope The scope
     * @param name The name.
     */
    public TypeFunction(ScopeIF scope, String name) {
        super(scope, name);
        this.parametros = new ArrayList();
    }

    public boolean addAParametros(Object e) {
        return parametros.add(e);
    }

    /**
     * Compares this object with another one.
     * @param other the other object.
     * @return true if two objects has the same properties.
     */
    public boolean equals(Object other) {
        // IMPORTANTE: a implementar por el estudiante
        //return super.equals(other);
        if (this == other) {
            return true;
        }

        if (!(this instanceof TypeBase)) {
            return false;
        }

        TypeBase aType = (TypeBase) other;
        return aType.getName().equals(this.getName());
    }

    /**
     * Returns a hash code for the object.
     */
    public int hashCode() {
        // IMPORTANTE: a implementar por el estudiante
        return 255 * getName().hashCode() + getScope().hashCode();
    }

    /**
     * Return a string representing the object.
     * @return a string representing the object.
     */
    public String toString() {
        // IMPORTANTE: a implementar por el estudiante
        //return super.toString();

        String str = "TypeFunction del ambito " + this.getScope().getLevel() + " con el nombre: " + this.getName() + " y que devuelve el tipo: " + this.getRetorno() + " y los parametros:";
        for (Iterator i = this.getParametros().iterator(); i.hasNext();) {
            str += "\n      " + i.next().toString();
        }

        return str;
    }
}
