package compiler.semantic.type;

import compiler.semantic.symbol.SymbolTable;
import compiler.semantic.symbol.SymbolVariable;
import es.uned.compiler.semantic.symbol.ScopeIF;
import es.uned.compiler.semantic.symbol.SymbolIF;
import es.uned.compiler.semantic.symbol.SymbolTableIF;
import es.uned.compiler.semantic.type.TypeBase;
import java.util.Iterator;

/**
 * Clase que representa un tipo registro
 * Ha de implementarse por el estudiante
 *
 */
public class TypeRecord
        extends TypeBase {

    private SymbolTableIF campos;
    private Integer size;

    public SymbolTableIF getCampos() {
        return campos;
    }

    public void addCampo(String name, SymbolVariable variable) {
        campos.setSymbol(name, variable);
    }

    public void addCampo(SymbolTableIF campos) {
        for (int i = 0; i < campos.getSymbols().size(); i++) {
            SymbolVariable v = (SymbolVariable) campos.getSymbols().get(i);
            addCampo(v.getName().toString(), v);
        }
    }

    public boolean containsCampo(String name) {
        return this.getCampos().containsSymbol(name);
    }

    public SymbolIF getCampo(String name) {
        return this.getCampos().getSymbol(name);
    }

    public void setSize(Integer size) {
        this.size = size;
    }

    public Integer getSize() {
        return this.size;
    }

    /**
     * Constructor for TypeBase.
     * @param scope The scope.
     */
    public TypeRecord(ScopeIF scope) {
        super(scope);
        this.campos = new SymbolTable();
    }

    /**
     * Constructor for TypeBase.
     * @param scope The scope
     * @param name The name.
     */
    public TypeRecord(ScopeIF scope, String name) {
        super(scope, name);
        this.campos = new SymbolTable();
    }

    /**
     * Constructor for TypeBase.
     * @param record The record to copy.
     */
    public TypeRecord(TypeRecord record) {
        super(record.getScope(), record.getName());
    }

    /**
     * Compares this object with another one.
     * @param other the other object.
     * @return true if two objects has the same properties.
     */
    @Override
    public boolean equals(Object other) {
        // IMPORTANTE: a implementar por el estudiante
        return super.equals(other);
    }

    /**
     * Returns a hash code for the object.
     */
    @Override
    public int hashCode() {
        // IMPORTANTE: a implementar por el estudiante
        return super.hashCode();
    }

    /**
     * Return a string representing the object.
     * @return a string representing the object.
     */
    @Override
    public String toString() {
        // IMPORTANTE: a implementar por el estudiante
        String str = new String();
        str = super.toString() + " (de tamao: " + this.getSize() + " que contiene los campos:";
        for (Iterator i = this.getCampos().getSymbols().iterator(); i.hasNext();) {
//            str += "\n      " + i.next().getClass().getSimpleName();
            str += "\n      " + i.next().toString();
        }
        return str;
    }
}
