/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package compiler.semantic.util;

import compiler.semantic.type.TypeArray;
import compiler.semantic.type.TypeEnum;
import compiler.semantic.type.TypeFunction;
import compiler.semantic.type.TypeProcedure;
import compiler.semantic.type.TypeRecord;
import compiler.semantic.type.TypeSimple;
import compiler.semantic.type.TypeTable;
import es.uned.compiler.semantic.symbol.Scope;
import es.uned.compiler.semantic.symbol.ScopeManager;
import es.uned.compiler.semantic.type.TypeIF;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

/**
 *
 * @author Administrador
 */
public class Utilidades {

//    public static final String INTEGER_STR = "entero";
    public static List getListFromHashMap(HashMap hm) {
        ArrayList list = new ArrayList();
        Iterator it = hm.values().iterator();
        while (it.hasNext()) {
            list.add(it.next());
        }
        return list;
    }

    public static boolean containsType(ScopeManager scopeManagerDeEntrada, String tipoABuscar) {
        //Busca em todos los scopes a ver si existe el tipo, buscandolo a partir de su string
        List scopes = scopeManagerDeEntrada.getCurrentScopes();
        Iterator it = scopes.iterator();
        Scope unScope;
        TypeTable unaTT;
        boolean found = false;
        while (it.hasNext() && !found) {
            unScope = (Scope) it.next();
            unaTT = (TypeTable) unScope.getTypeTable();
            found = unaTT.containsType(tipoABuscar);
        }
        return found;
    }

    public static TypeIF searchType(ScopeManager scopeManagerDeEntrada, String tipoABuscar) {
        //Busca em todos los scopes a ver si existe el tipo, buscandolo a partir de su string
        List scopes = scopeManagerDeEntrada.getCurrentScopes();
        Iterator it = scopes.iterator();
        Scope unScope;
        TypeTable unaTT;
        boolean found = false;
        while (it.hasNext() && !found) {
            unScope = (Scope) it.next();
            unaTT = (TypeTable) unScope.getTypeTable();
            if (unaTT.containsType(tipoABuscar)) {
                return unaTT.getType(tipoABuscar);
            }
        }
        return null;
    }

    public static TypeIF searchType(ScopeManager scopeManagerDeEntrada, TypeIF tipoABuscar) {
        List scopes = scopeManagerDeEntrada.getCurrentScopes();
        Iterator it = scopes.iterator();
        Scope unScope;
        TypeTable unaTT;
        boolean found = false;
        while (it.hasNext() && !found) {
            unScope = (Scope) it.next();
            unaTT = (TypeTable) unScope.getTypeTable();
            if (unaTT.containsType(tipoABuscar)) {
                return unaTT.getType(tipoABuscar.getName());
            }
        }
        return null;
    }

    public static Integer BuscaTamanyoTipo(ScopeManager scopeManagerDeEntrada, String tipoABuscar) {
        TypeIF tipo = searchType(scopeManagerDeEntrada, tipoABuscar);
        if (!tipo.equals(null)) {
            Integer idx;
            idx = tipo.getClass().toString().indexOf("Array");
            if (idx > 0) {
                return ((TypeArray) tipo).getSize();
            }
            idx = tipo.getClass().toString().indexOf("Enum");
            if (idx > 0) {
                return ((TypeEnum) tipo).getSize();
            }
            idx = tipo.getClass().toString().indexOf("Function");
            if (idx > 0) {
                return ((TypeFunction) tipo).getSize();
            }
            idx = tipo.getClass().toString().indexOf("Procedure");
            if (idx > 0) {
                return ((TypeProcedure) tipo).getSize();
            }
            idx = tipo.getClass().toString().indexOf("Record");
            if (idx > 0) {
                return ((TypeRecord) tipo).getSize();
            }
            idx = tipo.getClass().toString().indexOf("Simple");
            if (idx > 0) {
                return ((TypeSimple) tipo).getSize();
            }
        }
        return 0;
    }
}