package compiler.test;

import java.io.FileReader;
import compiler.lexical.Scanner;
import compiler.lexical.Token;
import es.uned.compiler.lexical.LexicalErrorManager;

/**
Esta clase contiene el mtodo main para probar el analizador lxico, 
sin tener terminado el sintctico. Puede aadirse cdigo si el alumno lo cree necesario, 
pero no ha de modificarse el proporcionado. 
*/
public class LexicalTestCase
{
    
    /**
     * Constructor for LexicalTestCase.
     */
    public LexicalTestCase ()
    {            
    }
        
       
    /** 
     * Tests the scanner.
     * @param test The test file.
     */
    public void testScan (String fileName)
    {
    	LexicalErrorManager lexicalErrorManager = new LexicalErrorManager ();
    	
        try
        {
        	lexicalErrorManager.lexicalInfo ("Fichero de entrada > " + fileName);
            FileReader aFileReader = new FileReader (fileName);
            Scanner aScanner = new Scanner (aFileReader);                 
          
            Object anObject = aScanner.next_token ();            
            while (anObject instanceof Token)
            {
                Token aToken = (Token) anObject;
                lexicalErrorManager.lexicalInfo (aToken);
                anObject = aScanner.next_token ();
            }
        }
        catch (Exception e)
        {
            e.printStackTrace ();
        }       
    }
      
	/**
	 * Starts the scanner test case.
	 * @param args An 1 element array containing the path to the input file. 
	 */
	public static void main(String args[])
    {    	
		if (args.length < 1 || args.length > 1) 
        {
            for (int i=0; i<args.length; i++) System.out.println (args[0]);
			System.err.println("Uso:  java LexicalTestCase ./test/ejemplo.m12");
		} 
		else 
        {
            LexicalTestCase lexicalTest = new LexicalTestCase ();
			String fileName = args[0];
            lexicalTest.testScan (fileName);				
		}		
	}	
}
