
package compiler.test;

import java.io.FileReader;
import compiler.lexical.Scanner;
import compiler.syntax.parser;
import es.uned.compiler.syntax.SyntaxErrorManager;

/**
 * Esta clase contiene el mtodo main para probar el analizador sintctico.
 * Puede modificarse si el alumno lo cree necesario, pero debe mantenerse el
 * nombre de la clase y su formato de invocacin (un parmetro de entrada a main
 * que contenga la ruta de un archivo fuente en modula 12.
 * Antes de ejecutarla hay que haber llamado a la tarea 'build' de ant.
 */
public class SyntaxTestCase
{
    /**
     * Constructor for SyntaxisTestCase.
     */
    public SyntaxTestCase ()
    {
    }

    /**
     * Tests the parser agains a test file.
     * @param fileName The path of the file test.
     */
    public void testParse (String fileName)
    {
        SyntaxErrorManager syntaxErrorManager = new SyntaxErrorManager ();
        
        try
        {
            syntaxErrorManager.syntaxInfo ("Fichero de entrada > " + fileName);
            FileReader aFileReader = new FileReader (fileName);
            Scanner aScanner = new Scanner (aFileReader);
            parser aParser = new parser (aScanner);
            aParser.parse (); 
        }
        catch (Exception e)
        {
            e.printStackTrace ();
        }
    }

    /**
     * Starts the parser test case.
     * @param args An 1 element array containing the path to the input file.
     */
    public static void main (String args[])
    {
        if (args.length < 1 || args.length > 1)
        {
            System.err.println ("Uso:  java SyntaxTestCase ./test/ejemplo.m12");
        }
        else
        {
            SyntaxTestCase syntaxTest = new SyntaxTestCase ();
            String fileName = args[0];
            syntaxTest.testParse (fileName);
        }
    }
}
